package actions

import (
	"projects/vue-buffalo-template/models"

	"github.com/gobuffalo/buffalo"
	"github.com/gobuffalo/pop"
	"github.com/pkg/errors"
)

// This file is generated by Buffalo. It offers a basic structure for
// adding, editing and deleting a page. If your model is more
// complex or you need more than the basic implementation you need to
// edit this file.

// Following naming logic is implemented in Buffalo:
// Model: Singular (Band)
// DB Table: Plural (bands)
// Resource: Plural (Bands)
// Path: Plural (/bands)
// View Template Folder: Plural (/templates/bands/)

// BandsResource is the resource for the Band model
type BandsResource struct {
	buffalo.Resource
}

// List gets all Bands. This function is mapped to the path
// GET /bands
func (v BandsResource) List(c buffalo.Context) error {
	// Get the DB connection from the context
	tx := c.Value("tx").(*pop.Connection)

	bands := &models.Bands{}

	// Paginate results. Params "page" and "per_page" control pagination.
	// Default values are "page=1" and "per_page=20".
	q := tx.PaginateFromParams(c.Params())

	// Retrieve all Bands from the DB
	if err := q.All(bands); err != nil {
		return errors.WithStack(err)
	}

	// Add the paginator to the headers so clients know how to paginate.
	c.Response().Header().Set("X-Pagination", q.Paginator.String())

	return c.Render(200, r.JSON(bands))
}

// Show gets the data for one Band. This function is mapped to
// the path GET /bands/{band_id}
func (v BandsResource) Show(c buffalo.Context) error {
	// Get the DB connection from the context
	tx := c.Value("tx").(*pop.Connection)

	// Allocate an empty Band
	band := &models.Band{}

	// To find the Band the parameter band_id is used.
	if err := tx.Find(band, c.Param("band_id")); err != nil {
		return c.Error(404, err)
	}

	return c.Render(200, r.JSON(band))
}

// New default implementation. Returns a 404
func (v BandsResource) New(c buffalo.Context) error {
	return c.Error(404, errors.New("not available"))
}

// Create adds a Band to the DB. This function is mapped to the
// path POST /bands
func (v BandsResource) Create(c buffalo.Context) error {
	// Allocate an empty Band
	band := &models.Band{}

	// Bind band to the html form elements
	if err := c.Bind(band); err != nil {
		return errors.WithStack(err)
	}

	// Get the DB connection from the context
	tx := c.Value("tx").(*pop.Connection)

	// Validate the data from the html form
	verrs, err := tx.ValidateAndCreate(band)
	if err != nil {
		return errors.WithStack(err)
	}

	if verrs.HasAny() {
		// Render errors as JSON
		return c.Render(400, r.JSON(verrs))
	}

	return c.Render(201, r.JSON(band))
}

// Edit default implementation. Returns a 404
func (v BandsResource) Edit(c buffalo.Context) error {
	return c.Error(404, errors.New("not available"))
}

// Update changes a Band in the DB. This function is mapped to
// the path PUT /bands/{band_id}
func (v BandsResource) Update(c buffalo.Context) error {
	// Get the DB connection from the context
	tx := c.Value("tx").(*pop.Connection)

	// Allocate an empty Band
	band := &models.Band{}

	if err := tx.Find(band, c.Param("band_id")); err != nil {
		return c.Error(404, err)
	}

	// Bind Band to the html form elements
	if err := c.Bind(band); err != nil {
		return errors.WithStack(err)
	}

	verrs, err := tx.ValidateAndUpdate(band)
	if err != nil {
		return errors.WithStack(err)
	}

	if verrs.HasAny() {
		// Render errors as JSON
		return c.Render(400, r.JSON(verrs))
	}

	return c.Render(200, r.JSON(band))
}

// Destroy deletes a Band from the DB. This function is mapped
// to the path DELETE /bands/{band_id}
func (v BandsResource) Destroy(c buffalo.Context) error {
	// Get the DB connection from the context
	tx := c.Value("tx").(*pop.Connection)

	// Allocate an empty Band
	band := &models.Band{}

	// To find the Band the parameter band_id is used.
	if err := tx.Find(band, c.Param("band_id")); err != nil {
		return c.Error(404, err)
	}

	if err := tx.Destroy(band); err != nil {
		return errors.WithStack(err)
	}

	return c.Render(200, r.JSON(band))
}
